// Communication variables

boolean connected = false;
int baud = 153600;

public void serialBegin(String port){

 clicSerialBegin = true ;
 serialBegin.setCaptionLabel("re-connect");

 myPort = new Serial(this, port, baud);
 println("Serial connection has begin on port " + port);
}

public void serialBegin(){
 if (clicSerialBegin == false)
 {
   clicSerialBegin = true ;
   serialBegin.setCaptionLabel("re-connect");
 }
 myPort = new Serial(this, Serial.list()[int(serialList.getValue())], baud);
 println("Serial connection has begin on port " + int(serialList.getValue()));
}

public void serialRefresh()
{
  clicSerialRefresh = true ;
  serialList.clear();
  serialList.addItems(Serial.list());
  println("Refreshing the serial list");
}

public void serialStop()
{
  clicSerialStop = true ;
  myPort.stop();
  connected = false;
  println("Serial connection has been stopped");
}

boolean inPacket = false;
int pack_type   = 0,
    data_length = 0,
    start_angle = 0,
    stop_angle  = 0,
    data_count = 0;

  
float start_angle_rad = 0,
      stop_angle_rad  = 0,
      angle_per_sample = 0,
      delta = 0;

void serialEvent(Serial p){
  if(connected == false) connected = true;
  
  if(!inPacket && p.available() >= 2){
    inPacket = (p.readChar() == 0xAA && p.readChar() == 0x55);
    println("-------------- Packet Start --------------");
  }
  
  if(p.available() >= 8 && inPacket){
    char[] headerBuffer = new char[8];
      for(int i = 0; i < 8; i++){
        headerBuffer[i] = p.readChar();
      }
        
      pack_type = headerBuffer[0];
      
      
      if (pack_type == 0x47) {
        //don't know what this is yet
        return;
      }

      if (pack_type == 0x45) {
        //don't know what this is yet
        return;
      }
  
      if (pack_type != 0x28) {
        //don't know what this is yet
        return;
      }
      
      data_length = headerBuffer[1];
      start_angle = (headerBuffer[3] << 8) | headerBuffer[2];
      start_angle_rad = ((float)start_angle / (float)0xb400) * TWO_PI;
      stop_angle = (headerBuffer[5] << 8) | headerBuffer[4];
      stop_angle_rad = ((float)stop_angle / (float)0xb400) * TWO_PI;
      
      delta = ((stop_angle_rad - start_angle_rad) + TWO_PI) % TWO_PI;
      angle_per_sample = delta / (data_length);
        
      println("[Serial] Header : t=", pack_type, " l=", data_length, " a0=", start_angle_rad, " a1=", stop_angle_rad);
  }
  
  while(p.available() >= 3 && inPacket && data_count < data_length){

    int data0 = int(p.readChar());
    int data1 = int(p.readChar());
    int data2 = int(p.readChar());
    
    int distance = (data2  << 8) + data1 ;
    float angle = (start_angle_rad + angle_per_sample * data_count);
    println("[Serial] Data : p", data_count,":[",data0,"i, ",distance/30000.0,"u, ",angle, "°]");
    
    Points.add(new PolarPoint(distance/20000.0, angle, data0));
    if(Points.size() > N){
      Points.remove(0); 
    }
    
    data_count++;
    
    if(data_count >= data_length){
      inPacket = false;
      data_length = 0;
      data_count = 0;
      println("-------------- End --------------");
      
    }
    
  }
    

  
}











void serialEventB(Serial p)
{
  if(connected == false) connected = true;
   
  int pack_type   = 0;
  int data_length = 0;
  int start_angle = 0;
  int stop_angle  = 0;

  if(p.available() >= 10){
    if(p.readChar() == 0xAA && p.readChar() == 0x55){
      char[] headerBuffer = new char[8];
      for(int i = 0; i < 8; i++){
        headerBuffer[i] = p.readChar();
      }
        
      pack_type = headerBuffer[0];
      data_length = headerBuffer[1];
      start_angle = headerBuffer[3] << 8 + headerBuffer[2];
      stop_angle = headerBuffer[5] << 8 + headerBuffer[4];
      
      int delta = stop_angle - start_angle;
      if(stop_angle < start_angle)
          delta =  0xB400 - start_angle + stop_angle;
  
        float angle_per_sample = 0;
        if(delta > 1)
          angle_per_sample = delta / (data_length-1);
      
      println("[Serial] Header : t=", pack_type, " l=", data_length, " a0=", start_angle, " a1=", stop_angle);
      
      for(int i = 0; i < data_length; i++){
        int data0 = int(p.readChar());
        int data1 = int(p.readChar());
        int data2 = int(p.readChar());
        
        int distance = (data2  << 8) + data1 ;
        float angle = (start_angle + angle_per_sample * i);
        float anglef = TWO_PI * (angle / 0xB400);
        
        println("[Serial] Data : p", i,":[",data0,", ",distance/300.0,", ",anglef, "]");
        Points.add(new PolarPoint(distance/300.0, anglef, data0));
      }
    }
  } 
}
